"use strict";

exports.__esModule = true;
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _utils = require("./utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Use = React.forwardRef(function (props, ref) {
  return render(Object.assign((0, _utils.omit)(props, "useNext"), {
    ref: ref,
    use: props.useNext
  }));
});

function render(props) {
  // filter Use and string components in the middle
  var _toArray$filter = (0, _utils.toArray)(props.use).filter(function (x, i, arr) {
    return x !== Use && (typeof x !== "string" || i === arr.length - 1);
  }),
      Component = _toArray$filter[0],
      useNext = _toArray$filter.slice(1);

  if (!Component) {
    return null;
  }

  var finalProps = (0, _utils.omit)(props, "use", "useNext");

  if (!useNext.length || typeof Component === "string") {
    return React.createElement(Component, finalProps);
  }

  if (useNext.length === 1) {
    return React.createElement(Component, _extends({}, finalProps, {
      use: useNext[0]
    }));
  }

  return React.createElement(Component, _extends({}, props, {
    use: Use,
    useNext: useNext
  }));
}

function isUseComponent(component) {
  return component && Array.isArray(component.uses);
}

function use() {
  for (var _len = arguments.length, uses = new Array(_len), _key = 0; _key < _len; _key++) {
    uses[_key] = arguments[_key];
  }

  var First = uses[0],
      next = uses.slice(1);

  if (isUseComponent(First) && (0, _utils.arrayContainsArray)(First.uses, next)) {
    return First;
  }

  var Component = React.forwardRef(function (props, ref) {
    return render(Object.assign((0, _utils.omit)(props, "useNext"), {
      ref: ref,
      use: uses.concat((0, _utils.toArray)(props.use), (0, _utils.toArray)(props.useNext))
    }));
  });
  Component.uses = uses;
  return Component;
}

var _default = use;
exports.default = _default;